/*
    Copyright (c) 2009 by Joseph Devietti (devietti@cs.washington.edu).

    This file is part of my DMP ASPLOS 2009 Presentation (DAP).

    DAP is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DAP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DAP.  If not, see <http://www.gnu.org/licenses/>.
*/ 

﻿package {
	import com.dncompute.graphics.*;
	import flash.display.*;
	import flash.events.*;
	import com.boostworthy.animation.management.*;
	import com.boostworthy.animation.easing.*;
	import com.boostworthy.animation.sequence.*;
	import com.boostworthy.animation.sequence.tweens.*;
	import com.boostworthy.animation.rendering.*;
	import com.boostworthy.geom.*;
	import com.boostworthy.core.Global;
	import flash.geom.*;
	
	/**
	 * view of DMP from 10,000 feet
	 */
	public class Sandbox extends Sprite {
		
		public function Sandbox():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private static var g_timeline:Timeline = new Timeline( RenderMethod.ENTER_FRAME );
		
		private var forward:Boolean = true;
		private function goahead(event:MouseEvent):void {
			if ( forward ) {
				g_timeline.play();
			} else {
				g_timeline.playReverse();
			}
			forward = !forward;
		}
		private function goback(event:KeyboardEvent):void {
			// HACK: super-fragile to hard-code value here, but Keyboard class doesn't 
			// have the right constants for some reason...
			if ( event.keyCode == 66 ) { 
				g_timeline.playReverse();
			}
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			//var wipe:Object = Wiper.wipe( s, Wiper.WIPE_DOWN, false );
			
			//g_timeline = new Timeline( RenderMethod.ENTER_FRAME );
			g_timeline.gotoAndStop( 1 );
			Global.stage = stage;
			stage.addEventListener( MouseEvent.CLICK, goahead );
			stage.addEventListener( KeyboardEvent.KEY_DOWN, goback );

			
			var arrow:Sprite = new TextLineArrow( 100, 100, 0, 0, "HELLO" );
			addChild( arrow );

			//var o:Object = Wiper.wipe( arrow, Wiper.WIPE_DOWN, true, true/*debug*/ );
			
			var mask:Sprite = new Sprite();
			var bounds:Rectangle = arrow.getBounds( arrow );
			
			trace( "bounds: " + bounds.toString() );
			
			mask.graphics.lineStyle();
			mask.graphics.beginFill( 0x0, 0.5 );
			// need to have (0,0) at the rightmost edge of the mask
			var size:Number = Math.max( Point.distance(bounds.topLeft,bounds.bottomRight),
				Point.distance(new Point(bounds.left,bounds.bottom),new Point(bounds.right,bounds.top)) );
			mask.graphics.drawRect( (-size)/*-2*/, -size/2, size, size );
			mask.graphics.endFill();
			
			//mask.graphics.beginFill( 0x00ff00 );
			//mask.graphics.drawCircle( 0, 0, 1 );
			
			// the point (0,0) moves along the path
			var path:Path = new Path();
			path.clear();
			path.moveTo( bounds.right, bounds.bottom );
			path.lineTo( bounds.left, bounds.top );
			
			// apply transforms
			//var xform:Matrix = new Matrix();
			
			trace( path.getAngleAt( 1.0 ) ); // -135 degrees! explains weird flipping at end of path
			
			// orient mask to path
			//xform.rotate( path.getAngleAt(0.0) * Math.PI / 180 ); // getAngleAt() returns degrees
			
			//mask.transform.matrix = xform;
			
			this.graphics.lineStyle( 2, 0xFF0000 );
			path.draw( this.graphics );
			
			arrow.addChild( mask );
			arrow.mask = mask;
			g_timeline.addTween( new PathTween(mask, path, true, Anim.Start(),
				Anim.StopIncr(60),Transitions.LINEAR) );
			
			//g_timeline.play();
			
			/*
			// Create a new animation manager.
			var m_objAnimationManager:AnimationManager = new AnimationManager();
			// for masks, movement is in mask coord space
			m_objAnimationManager.move( wipe.mask, wipe.x, wipe.y, 1500, Transitions.CUBIC_IN_AND_OUT );
						
			s = new Sprite();
			s.graphics.lineStyle( 1 );
			s.graphics.beginFill( 0x0000FF );
			s.graphics.drawRect( 0, 0, 100, 200 );
			s.graphics.endFill();
			addChild( s );
			s.x = 200; s.y = 30;
			m_objAnimationManager.move( s, 200, 60, 5000, Transitions.CUBIC_OUT );
			
			var ah:ArrowStyle = new ArrowStyle( {shaftThickness:10, headWidth:20.0} );
			var a:Sprite = new LineArrow( 10, 10, 150, 200, ah, 0xCCCCCC );
			addChild( a );
			m_objAnimationManager.property( a, "x2", 60, 3000, Transitions.CUBIC_OUT );
			m_objAnimationManager.property( a, "y2", 160, 3000, Transitions.CUBIC_OUT );
			*/
			
			/*
			var s:Sprite = new TextLineArrow( 125, 125, 25, 150, "HELLO", 0x0 );
			addChild( s );
			
			s = new TextLineArrow( 125, 85, 25, 25, "HOWDY", 0x0 );
			addChild( s );
			
			s = new TextLineArrow( 200, 100, 250, 200, "JOEBO", 0x0 );
			addChild( s );
			
			s = new TextLineArrow( 200, 150, 300, 100, "ARROW", 0x0 );
			addChild( s );
			*/
		}
		
	}
	
}